<form novalidate
      (ngSubmit)="save()"
      [formGroup]="scheduleForm"
      style="margin: 40px 0">

  <div class="form-group">
    <label for="name">Name</label>
    <input type="text"
           class="form-control"
           id="name"
           placeholder="Enter name"
           formControlName="name"
           [ngClass]="{'is-invalid': (scheduleForm.get('name').touched ||
                                                scheduleForm.get('name').dirty) &&
                                                !scheduleForm.get('name').valid}"/>
    <span class="invalid-feedback">
                        <span *ngIf="scheduleForm.get('name').errors?.required">
                            Please enter your name.
                        </span>
        </span>
  </div>

  <div class="form-group">
    <label for="email">Email</label>
    <input type="text"
           class="form-control"
           id="email"
           placeholder="Enter email"
           formControlName="email"
           [ngClass]="{'is-invalid': (scheduleForm.get('email').touched ||
                                                scheduleForm.get('email').dirty) &&
                                                !scheduleForm.get('email').valid}"/>
    <span class="invalid-feedback">
                        <span *ngIf="scheduleForm.get('email').errors?.required">
                            Please enter the email.
                        </span>
        </span>
  </div>

  <div class="form-group">
    <label for="appointment-date">Appointment Date</label>
    <select class="form-input d-block"
            name="time" id="appointment-date"
            formControlName="date"
            [ngClass]="{'is-invalid': (scheduleForm.get('date').touched ||
                                                scheduleForm.get('date').dirty) &&
                                                !scheduleForm.get('date').valid}">
      <option value="">Date</option>
      <ng-container *ngFor="let date of availableDates">
        <option value="{{date.date}}">{{date.date}}</option>
      </ng-container>
    </select>
    <span class="invalid-feedback">
                        <span *ngIf="scheduleForm.get('date').errors?.required">
                            Please choose a date.
                        </span>
        </span>
  </div>

  <div class="form-group">
    <label for="time">Appointment Time</label>
    <select class="form-input d-block"
            name="time"
            id="time"
            formControlName="time"
            [ngClass]="{'is-invalid': (scheduleForm.get('time').touched ||
                                                scheduleForm.get('time').dirty) &&
                                                !scheduleForm.get('time').valid}">
      <option value="">Time</option>
      <ng-container *ngFor="let availableTime of availableTimes[scheduleForm.value.date]">
        <option value="{{availableTime.time}}">{{availableTime.time}}</option>
      </ng-container>
    </select>
    <span class="invalid-feedback">
                        <span *ngIf="scheduleForm.get('time').errors?.required">
                            Please choose a time.
                        </span>
        </span>
  </div>

  <button class="btn btn-primary"
          type="submit"
          [title]="scheduleForm.valid ? 'Save your entered data' : 'Disabled until the form data is valid'"
          [disabled]="!scheduleForm.valid">
    Book appointment
  </button>
</form>
